#!/usr/bin/wish
#
# Metaverse Main Module 
# 
# this file initalizes the program and does any
# platform specific things/setup. It will then source 
# supporting modules.
#
# Module Name		- Main Module
# Current Revision No.	- 0.4
# Current Maintainter 	- Cruise <cruise@drunkenbastards.org>
# Last update 		- Mon Oct  4 07:39:03 EDT 1999
# Sourced By		- Command Line
#
# Copyright (C) 1999 David Gale <cruise@drunkenbastards.org>
# For more information visit http://metaverse.daytona.com/Metaverse/
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
# USA.

global MV

if {$argv0 != ""} {
	set app "$argv0"
} else {
	set app [pwd]
}

catch { set app [file readlink "$app"] }

switch [array get tcl_platform platform] {
	"platform macintosh" {
		#
		# This seems to work if you put the wish
		# binary in the dir you are starting from.
		#
		set MV(homedir) "."
		set MV(libdir) "$MV(homedir)/lib"
	} 
	"platform unix" {
		#
		# UNIX just rules, this should take care of all
		# startup problems for this platform including user
		# errors.
		#
		set MV(homedir) "~/.Metaverse"
		set MV(libdir) "/usr/lib/Metaverse/lib"
		if ![file exists $MV(homedir)] {
			file mkdir $MV(homedir)
			file mkdir $MV(homedir)/images
			file mkdir $MV(homedir)/rimages
			file mkdir $MV(homedir)/anims
			file mkdir $MV(homedir)/rooms
			file mkdir $MV(homedir)/plugins
			file mkdir $MV(homedir)/plugins/Query
			file mkdir $MV(homedir)/objects
			file mkdir $MV(homedir)/icons
			file mkdir $MV(homedir)/download
			file copy "/usr/lib/Metaverse/images/default.gif" "$MV(homedir)/images"
			file copy "/usr/lib/Metaverse/anims/default.av" "$MV(homedir)/anims"
			file copy "/usr/lib/Metaverse/rooms/room.gif" "$MV(homedir)/rooms"
			file copy "/usr/lib/Metaverse/plugins/Query/PlugInit.tcl" "$MV(homedir)/plugins/Query"
			file copy "/usr/lib/Metaverse/icons/unknown.gif" "$MV(homedir)/icons/unknown.gif"
			file copy "/usr/lib/Metaverse/icons/dccfile.gif" "$MV(homedir)/icons/dccfile.gif"
			file copy "/usr/lib/Metaverse/icons/mv2.xbm" "$MV(homedir)/icons/mv2.xbm"
			file copy "/usr/lib/Metaverse/icons/mv2.xpm" "$MV(homedir)/icons/mv2.xpm"
			file copy "/usr/lib/Metaverse/icons/mv2.gif" "$MV(homedir)/icons/mv2.gif"
			file copy "/usr/lib/Metaverse/icons/unlocked.gif" "$MV(homedir)/icons/unlocked.gif"
			file copy "/usr/lib/Metaverse/icons/locked.gif" "$MV(homedir)/icons/locked.gif"
		}
		if ![file exists $MV(homedir)/images] {
			file mkdir $MV(homedir)/images
			file copy "/usr/lib/Metaverse/images/default.gif" "$MV(homedir)/images"
		}
		if ![file exists $MV(homedir)/icons] {
			file mkdir $MV(homedir)/icons
			file copy "/usr/lib/Metaverse/icons/unknown.gif" "$MV(homedir)/icons/unknown.gif"
			file copy "/usr/lib/Metaverse/icons/dccfile.gif" "$MV(homedir)/icons/dccfile.gif"
			file copy "/usr/lib/Metaverse/icons/mv2.xpm" "$MV(homedir)/icons/mv2.xpm"
			file copy "/usr/lib/Metaverse/icons/mv2.xbm" "$MV(homedir)/icons/mv2.xbm"
			file copy "/usr/lib/Metaverse/icons/mv2.gif" "$MV(homedir)/icons/mv2.gif"
			file copy "/usr/lib/Metaverse/icons/unlocked.gif" "$MV(homedir)/icons/unlocked.gif"
			file copy "/usr/lib/Metaverse/icons/locked.gif" "$MV(homedir)/icons/locked.gif"
		}
		if ![file exists $MV(homedir)/icons/dccfile.gif] {
			file copy "/usr/lib/Metaverse/icons/dccfile.gif" "$MV(homedir)/icons/dccfile.gif"
		}
		if ![file exists $MV(homedir)/icons/unlocked.gif] {
			file copy "/usr/lib/Metaverse/icons/unlocked.gif" "$MV(homedir)/icons/unlocked.gif"
		}
		if ![file exists $MV(homedir)/icons/locked.gif] {
			file copy "/usr/lib/Metaverse/icons/locked.gif" "$MV(homedir)/icons/locked.gif"
		}
		if ![file exists $MV(homedir)/icons/unknown.gif] {
			file copy "/usr/lib/Metaverse/icons/unknown.gif" "$MV(homedir)/icons/unknown.gif"
		}
		if ![file exists $MV(homedir)/icons/mv2.gif] {
			file copy "/usr/lib/Metaverse/icons/mv2.gif" "$MV(homedir)/icons/mv2.gif"
		}
		if ![file exists $MV(homedir)/icons/mv2.xpm] {
			file copy "/usr/lib/Metaverse/icons/mv2.xpm" "$MV(homedir)/icons/mv2.xpm"
		}
		if ![file exists $MV(homedir)/icons/mv2.xbm] {
			file copy "/usr/lib/Metaverse/icons/mv2.xbm" "$MV(homedir)/icons/mv2.xbm"
		}
		if ![file exists $MV(homedir)/plugins] {
			file mkdir $MV(homedir)/plugins
			file mkdir $MV(homedir)/plugins/Query
			file copy "/usr/lib/Metaverse/plugins/Query/PlugInit.tcl" "$MV(homedir)/plugins/Query"
		}
		if ![file exists $MV(homedir)/anims] {
			file mkdir $MV(homedir)/anims
			file copy "/usr/lib/Metaverse/anims/default.av" "$MV(homedir)/anims"
		}
		if ![file exists $MV(homedir)/rooms] {
			file mkdir $MV(homedir)/rooms
			file copy "/usr/lib/Metaverse/rooms/room.gif" "$MV(homedir)/rooms"
		}
		if ![file exists $MV(homedir)/images/default.gif] {
			file copy "/usr/lib/Metaverse/images/default.gif" "$MV(homedir)/images"
		}
		if ![file exists $MV(homedir)/anims/default.av] {
			file copy "/usr/lib/Metaverse/anims/default.av" "$MV(homedir)/anims"
		}
		if ![file exists $MV(homedir)/rooms/room.gif] {
			file copy "/usr/lib/Metaverse/rooms/room.gif" "$MV(homedir)/rooms"
		}
		wm iconbitmap . @$MV(homedir)/icons/mv2.xbm
	}
	default {
		#
		# Windows! This section needs some more work
		# since windows does not really support a safe
		# central location for metaverse, there is really
		# no way to protect against users who delete things.
		#
		set MV(homedir) "[file dirname "$app"]"
		set MV(libdir) "$MV(homedir)/lib"
		#wm iconbitmap . @$MV(homedir)/icons/mv2.ico
	}
} 

if ![file exists $MV(homedir)/rimages] {file mkdir $MV(homedir)/rimages}
if ![file exists $MV(homedir)/download] {file mkdir $MV(homedir)/download}
if ![file exists $MV(homedir)/objects] {file mkdir $MV(homedir)/objects}

source "$MV(libdir)/Globals.tcl"
source "$MV(libdir)/IOFuncs.tcl"
source "$MV(libdir)/BaseFunc.tcl"
source "$MV(libdir)/InitMain.tcl"
