# Metaverse InitMainWindow
# 
# this file initalizes the program and does any
# platform specific things/setup. It will then source 
# supporting modules.
#
# Module Name		- Init Main Window Module
# Current Revision No.	- 0.3
# Current Maintainter 	- Cruise <cruise@drunkenbastards.org>
# Last update 		- Mon Sep 20 22:07:28 EDT 1999
# Sourced By		- Main Module
#
# Copyright (C) 1999 David Gale <cruise@drunkenbastards.org>
# For more information visit http://metaverse.daytona.com/Metaverse/
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
# USA.


source "$MV(libdir)/Passage.tcl"
source "$MV(libdir)/SetFuncs.tcl"
source "$MV(libdir)/Avatars.tcl"
source "$MV(libdir)/ChtFuncs.tcl"
source "$MV(libdir)/AvEd.tcl"
source "$MV(libdir)/URL.tcl"

wm title . "Welcome To The Metaverse!"
wm resizable . 0 0

frame .menu -relief sunken -borderwidth 2 \
	-bg $MV(colors.frames.topbar.bg)

frame .top -relief sunken -borderwidth 2 \
	-bg $MV(colors.frames.canvas.bg)

frame .menu.r
frame .menu.r.a
frame .menu.r.b

button .menu.r.b.connect -text Connect -command "Connect" \
	-bg $MV(colors.buttons.connect.bg) -fg $MV(colors.buttons.connect.fg) \
	-activebackground $MV(colors.buttons.connect.abg) \
	-activeforeground $MV(colors.buttons.connect.afg)

frame .menu.r.a.chat -relief raised -borderwidth 2 \
	-bg $MV(colors.frames.chat.bg)

button .menu.r.a.chat.send -text Send -command SendText \
	-bg $MV(colors.buttons.send.bg) -fg $MV(colors.buttons.send.fg) \
	-activebackground $MV(colors.buttons.send.abg) \
	-activeforeground $MV(colors.buttons.send.afg)

entry .menu.r.a.chat.chat \
	-bg $MV(colors.buttons.entry.bg) -fg $MV(colors.buttons.entry.fg)

canvas .top.c -height 480.0 -width 640.0

frame .menu.m -relief raised -borderwidth 2 \
	-bg $MV(colors.frames.menu.bord.bg) 

frame .menu.m.a -relief sunken -borderwidth 2 \
	-bg $MV(colors.frames.menu.top.bg) 

frame .menu.m.b -relief sunken -borderwidth 2 \
	-bg $MV(colors.frames.menu.bot.bg) 


button .menu.m.a.quit -text Quit -command {exit} \
	-bg $MV(colors.buttons.quit.bg) -fg $MV(colors.buttons.quit.fg) \
	-activebackground $MV(colors.buttons.quit.abg) \
	-activeforeground $MV(colors.buttons.quit.afg)

button .menu.m.a.chat -text "Text Chat" -command ToggleText \
	-bg $MV(colors.buttons.textchat.bg) -fg $MV(colors.buttons.textchat.fg) \
	-activebackground $MV(colors.buttons.textchat.abg) \
	-activeforeground $MV(colors.buttons.textchat.afg)

button .menu.m.a.setup -text Setup -command Setup \
	-bg $MV(colors.buttons.setup.bg) -fg $MV(colors.buttons.setup.fg) \
	-activebackground $MV(colors.buttons.setup.abg) \
	-activeforeground $MV(colors.buttons.setup.afg)

menubutton .menu.m.a.bookmarks -text "Passageways" -menu \
	 .menu.m.a.bookmarks.m -relief raised -borderwidth 2 \
	-bg $MV(colors.buttons.passageways.bg) -fg $MV(colors.buttons.passageways.fg) \
	-activebackground $MV(colors.buttons.passageways.abg) \
	-activeforeground $MV(colors.buttons.passageways.afg)
menu .menu.m.a.bookmarks.m

button .menu.m.b.avatars -text AvEd -relief raised -borderwidth 2 \
	-bg $MV(colors.buttons.aved.bg) -fg $MV(colors.buttons.aved.fg) \
	-activebackground $MV(colors.buttons.aved.abg) \
	-activeforeground $MV(colors.buttons.aved.afg) -command AvEd

checkbutton .menu.m.b.anim -text Animate -variable MV(anim.stop) -relief raised \
	-borderwidth 2 -offvalue 1 -onvalue 0 -command AnimateAvatar \
	-bg $MV(colors.buttons.animate.bg) -fg $MV(colors.buttons.animate.fg) \
	-activebackground $MV(colors.buttons.animate.abg) \
	-activeforeground $MV(colors.buttons.animate.afg)

menubutton .menu.m.b.anims -text Avatars -menu .menu.m.b.anims.m -relief \
	raised -borderwidth 2 \
	-bg $MV(colors.buttons.avatars.bg) -fg $MV(colors.buttons.avatars.fg) \
	-activebackground $MV(colors.buttons.avatars.abg) \
	-activeforeground $MV(colors.buttons.avatars.afg)
menu .menu.m.b.anims.m

checkbutton .menu.m.b.sound -text Sound -variable MV(bell) -relief raised \
	-borderwidth 2 \
	-bg $MV(colors.buttons.sound.bg) -fg $MV(colors.buttons.sound.fg) \
	-activebackground $MV(colors.buttons.sound.abg) \
	-activeforeground $MV(colors.buttons.sound.afg)

frame .menu.m.b.names -relief raised -borderwidth 2 \
	-bg $MV(colors.frames.names.bg)

checkbutton .menu.m.b.names.cb -variable MV(names) -command ShowNames \
	-bg $MV(colors.buttons.names.chk.bg) -fg $MV(colors.buttons.names.chk.fg) \
	-activebackground $MV(colors.buttons.names.chk.abg) \
	-activeforeground $MV(colors.buttons.names.chk.afg)

menubutton .menu.m.b.names.mb -text Names -relief raised -borderwidth 2 \
	-menu .menu.m.b.names.mb.m \
	-bg $MV(colors.buttons.names.bg) -fg $MV(colors.buttons.names.fg) \
	-activebackground $MV(colors.buttons.names.abg) \
	-activeforeground $MV(colors.buttons.names.afg)
menu .menu.m.b.names.mb.m

pack .menu -side top -fill both -expand y 
pack .top -fill both -expand y

pack .menu.m -side left
pack .menu.r -side left -fill both -expand y
pack .menu.r.a -side top -fill both -expand y
pack .menu.r.b -side top -fill both -expand y
pack .menu.m.a -side top -fill both -expand y
pack .menu.m.b -side bottom -fill both -expand y
pack .menu.m.a.quit .menu.m.a.chat .menu.m.a.setup .menu.m.a.bookmarks -side left -fill both -expand y
pack .menu.m.b.avatars .menu.m.b.anim .menu.m.b.anims .menu.m.b.sound .menu.m.b.names -side left -fill both -expand y
pack .menu.m.b.names.cb .menu.m.b.names.mb -side left
pack .menu.r.a.chat -side left -fill x -expand y
pack .menu.r.a.chat.send -side left 
pack .menu.r.a.chat.chat -side left -fill x -expand y
pack .menu.r.b.connect -side left -fill both -expand y

pack .top.c


bind . <Return> SendText
bind . <Tab> {NickComplete}
bind . <Control-d> {ToggleDebug}
bind . <Up> "ShowPrev .menu.r.a.chat.chat"
bind . <Down> "ShowNext .menu.r.a.chat.chat"
bind .menu.r.a.chat.chat <Key> "CheckLen .menu.r.a.chat.chat"

if ![file exists "$MV(configfile)"] {
	Setup
	AnimateMe "$MV(anim)" 3
	set MV($MV(nick).haschat) 0
	set MV($MV(nick).chatque) {}
} else {
	source "$MV(configfile)"
	AnimateMe "$MV(anim)" 3
	set MV($MV(nick).haschat) 0
	set MV($MV(nick).chatque) {}
}

image create photo room -file "$MV(roomdir)/room.gif"

if [file exists "$MV(images)/$MV(avatar)"] {
	image create photo pic -file "$MV(images)/$MV(avatar)"
} else {
	image create photo pic -file "$MV(images)/default.gif"
}
focus .menu.r.a.chat.chat

.top.c create image 320 240 -image room
set MV(img) [.top.c create image 320 200 -image pic]
if $MV(names) {ShowName $MV(nick)}
bind .top.c <Button-1> {MoveTo %x %y}

# Done with Metaverse initalization. Init external plugins.
source "$MV(libdir)/Plugin.tcl"

# Some final things to do before we exit.
DoAvatars
DoBookmarks
CheckTimeouts
